# JSON:API Advanced Permissions

## Overview

The **JSON:API Advanced Permissions** module provides a powerful way to manage
access control for JSON:API collections.
This module allows developers and administrators to dynamically add
role-based permissions for various HTTP methods (GET, PATCH, PUT, POST, DELETE)
to ensure precise control over who can access specific API endpoints.

## Requirements

This module requires no modules outside of Drupal core.

## Features

- Dynamic role-based permissions for JSON:API collections.
- Supports all major HTTP methods: GET, PATCH, PUT, POST, DELETE.
- Simplified management of API access for different roles.
- Extends the `RouteSubscriberBase` for enhanced route alteration.

## Installation

1. Download the module:
   ```
   composer require drupal/jsonapi_advanced_permissions
   ```

2. Enable the module:
   ```
   drush en jsonapi_advanced_permissions
   ```

3. Clear the cache:
   ```
   drush cr
   ```

## Configuration

To configure the JSON:API Advanced Permissions module:

1. Navigate to 
**Configuration** > **Web Services** > **JSON:API Advanced Permissions**.
2. Define roles and permissions for specific JSON:API collections.
3. Select the HTTP methods that each role can access.

## Usage

The module provides an easy way to create
granular access rules for JSON:API endpoints. 

You can define access control rules by specifying:

- The role to be granted or restricted access.
- The specific collection (e.g., `node--article`, `taxonomy_term--tags`).
- The HTTP method allowed (GET, PATCH, etc.).

## Dependencies

- **Drupal Core** (version 10+)
- **JSON:API** module
